#include "EsoAcsammm_Header.hpp"
// ++++++++++++++++++++++++++++++++++
// + Code generated by dcc 1.0      +
// ++++++++++++++++++++++++++++++++++
void a1_res(int bmode_1, double* yy, double* a1_yy, double* der_x, double* a1_der_x, double* x, double* a1_x, double* p, double* a1_p, int* condit, int* lock, int* prev, int& n_x, int& n_p, int& n_c)
#pragma ad indep x a1_x p a1_p a1_yy
#pragma ad dep yy a1_x a1_p
{
   int i_E=0;
   int i_C=0;
   int i__=0;
   int j__=0;
   double kk__=0;
   double a1_kk__=0;
   int k__=0;
   int m__=0;
   int r_i=0;
   int r_j=0;
   int i_a=0;
   int i_b=0;
   int i_loop=0;
   int i__switch=0;
   int i__start=0;
   int i__end=0;
   int i__step=0;
   int while_end=0;
   int i_cont=0;
   int j_cont=0;
   int k_cont=0;
   double var_ttime=0;
   double a1_var_ttime=0;
   double der_var_ttime=0;
   double a1_der_var_ttime=0;
   double var_dist=0;
   double a1_var_dist=0;
   double der_var_dist=0;
   double a1_der_var_dist=0;
   double var_velo=0;
   double a1_var_velo=0;
   double der_var_velo=0;
   double a1_der_var_velo=0;
   double var_accel=0;
   double a1_var_accel=0;
   double der_var_accel=0;
   double a1_der_var_accel=0;
   double var_obj=0;
   double a1_var_obj=0;
   double der_var_obj=0;
   double a1_der_var_obj=0;
   double par_alpha=0;
   double a1_par_alpha=0;
   double par_k=0;
   double a1_par_k=0;
   double var_exp0=0;
   double a1_var_exp0=0;
   double var_i_expr=0;
   double a1_var_i_expr=0;
   int i_i=0;
   int i_j=0;
   int i_z=0;
   int i_dims_as_one=0;
   double v1_0=0;
   double a1_v1_0=0;
   double v1_1=0;
   double a1_v1_1=0;
   double v1_2=0;
   double a1_v1_2=0;
   double v1_3=0;
   double a1_v1_3=0;
   double v1_4=0;
   double a1_v1_4=0;
   double v1_5=0;
   double a1_v1_5=0;
   double v1_6=0;
   double a1_v1_6=0;
   double v1_7=0;
   double a1_v1_7=0;
   double v1_8=0;
   double a1_v1_8=0;
   double v1_9=0;
   double a1_v1_9=0;
   int save_acs_cs_c=0;
   save_acs_cs_c=acs_cs_c;
   if (bmode_1==1) {
      // augmented forward section
      acs_cs[acs_cs_c]=0; acs_cs_c=acs_cs_c+1;
      acs_fds[acs_fds_c]=var_ttime; acs_fds_c=acs_fds_c+1; var_ttime=x[0];
      acs_fds[acs_fds_c]=der_var_ttime; acs_fds_c=acs_fds_c+1; der_var_ttime=der_x[0];
      acs_fds[acs_fds_c]=var_dist; acs_fds_c=acs_fds_c+1; var_dist=x[1];
      acs_fds[acs_fds_c]=der_var_dist; acs_fds_c=acs_fds_c+1; der_var_dist=der_x[1];
      acs_fds[acs_fds_c]=var_velo; acs_fds_c=acs_fds_c+1; var_velo=x[2];
      acs_fds[acs_fds_c]=der_var_velo; acs_fds_c=acs_fds_c+1; der_var_velo=der_x[2];
      acs_fds[acs_fds_c]=var_accel; acs_fds_c=acs_fds_c+1; var_accel=x[3];
      acs_fds[acs_fds_c]=der_var_accel; acs_fds_c=acs_fds_c+1; der_var_accel=der_x[3];
      acs_fds[acs_fds_c]=var_obj; acs_fds_c=acs_fds_c+1; var_obj=x[4];
      acs_fds[acs_fds_c]=der_var_obj; acs_fds_c=acs_fds_c+1; der_var_obj=der_x[4];
      acs_fds[acs_fds_c]=par_alpha; acs_fds_c=acs_fds_c+1; par_alpha=p[0];
      acs_fds[acs_fds_c]=par_k; acs_fds_c=acs_fds_c+1; par_k=p[1];
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=der_var_ttime-(1);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=der_var_dist-(var_velo);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=der_var_velo-(var_accel-par_alpha*var_velo*var_velo);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=var_i_expr; acs_fds_c=acs_fds_c+1; var_i_expr=0-var_velo*var_velo;
      bmode_1=2; // store inputs and run original code
      a1_acs_exp(bmode_1,var_i_expr,a1_var_i_expr,var_exp0,a1_var_exp0);
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_accel-(par_k*var_exp0);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_obj-(0-var_dist);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_ids[acs_ids_c]=n_c; acs_ids_c=acs_ids_c+1; n_c=i_C;
      // reverse section
      while (acs_cs_c>save_acs_cs_c) {
        acs_cs_c=acs_cs_c-1;
        if (acs_cs[acs_cs_c]==0) {
          acs_ids_c=acs_ids_c-1; n_c=acs_ids[acs_ids_c];
          acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
          acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
          v1_0=var_obj;
          v1_1=var_dist;
          v1_2=-v1_1;
          v1_3=v1_2;
          v1_4=v1_0-v1_3;
          a1_v1_4=a1_yy[i_E]; a1_yy[i_E]=0;
          a1_v1_0=a1_v1_4; a1_v1_3=0-a1_v1_4;
          a1_v1_2=a1_v1_3;
          a1_v1_1=-a1_v1_2;
          a1_var_dist=a1_var_dist+a1_v1_1;
          a1_var_obj=a1_var_obj+a1_v1_0;
          acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
          acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
          v1_0=var_accel;
          v1_1=par_k;
          v1_2=var_exp0;
          v1_3=v1_1*v1_2;
          v1_4=v1_3;
          v1_5=v1_0-v1_4;
          a1_v1_5=a1_yy[i_E]; a1_yy[i_E]=0;
          a1_v1_0=a1_v1_5; a1_v1_4=0-a1_v1_5;
          a1_v1_3=a1_v1_4;
          a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
          a1_var_exp0=a1_var_exp0+a1_v1_2;
          a1_par_k=a1_par_k+a1_v1_1;
          a1_var_accel=a1_var_accel+a1_v1_0;
          bmode_1=1; // restore and joint reversal
          a1_acs_exp(bmode_1,var_i_expr,a1_var_i_expr,var_exp0,a1_var_exp0);
          acs_fds_c=acs_fds_c-1; var_i_expr=acs_fds[acs_fds_c];
          v1_0=var_velo;
          v1_1=var_velo;
          v1_2=v1_0*v1_1;
          v1_3=-v1_2;
          a1_v1_3=a1_var_i_expr; a1_var_i_expr=0;
          a1_v1_2=-a1_v1_3;
          a1_v1_0=v1_1*a1_v1_2; a1_v1_1=v1_0*a1_v1_2;
          a1_var_velo=a1_var_velo+a1_v1_1;
          a1_var_velo=a1_var_velo+a1_v1_0;
          acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
          acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
          v1_0=der_var_velo;
          v1_1=var_accel;
          v1_2=par_alpha;
          v1_3=var_velo;
          v1_4=v1_2*v1_3;
          v1_5=var_velo;
          v1_6=v1_4*v1_5;
          v1_7=v1_1-v1_6;
          v1_8=v1_7;
          v1_9=v1_0-v1_8;
          a1_v1_9=a1_yy[i_E]; a1_yy[i_E]=0;
          a1_v1_0=a1_v1_9; a1_v1_8=0-a1_v1_9;
          a1_v1_7=a1_v1_8;
          a1_v1_1=a1_v1_7; a1_v1_6=0-a1_v1_7;
          a1_v1_4=v1_5*a1_v1_6; a1_v1_5=v1_4*a1_v1_6;
          a1_var_velo=a1_var_velo+a1_v1_5;
          a1_v1_2=v1_3*a1_v1_4; a1_v1_3=v1_2*a1_v1_4;
          a1_var_velo=a1_var_velo+a1_v1_3;
          a1_par_alpha=a1_par_alpha+a1_v1_2;
          a1_var_accel=a1_var_accel+a1_v1_1;
          a1_der_var_velo=a1_der_var_velo+a1_v1_0;
          acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
          acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
          v1_0=der_var_dist;
          v1_1=var_velo;
          v1_2=v1_1;
          v1_3=v1_0-v1_2;
          a1_v1_3=a1_yy[i_E]; a1_yy[i_E]=0;
          a1_v1_0=a1_v1_3; a1_v1_2=0-a1_v1_3;
          a1_v1_1=a1_v1_2;
          a1_var_velo=a1_var_velo+a1_v1_1;
          a1_der_var_dist=a1_der_var_dist+a1_v1_0;
          acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
          acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
          v1_0=der_var_ttime;
          v1_1=1;
          v1_2=v1_1;
          v1_3=v1_0-v1_2;
          a1_v1_3=a1_yy[i_E]; a1_yy[i_E]=0;
          a1_v1_0=a1_v1_3; a1_v1_2=0-a1_v1_3;
          a1_v1_1=a1_v1_2;
          a1_der_var_ttime=a1_der_var_ttime+a1_v1_0;
          acs_fds_c=acs_fds_c-1; par_k=acs_fds[acs_fds_c];
          v1_0=p[1];
          a1_v1_0=a1_par_k; a1_par_k=0;
          a1_p[1]=a1_p[1]+a1_v1_0;
          acs_fds_c=acs_fds_c-1; par_alpha=acs_fds[acs_fds_c];
          v1_0=p[0];
          a1_v1_0=a1_par_alpha; a1_par_alpha=0;
          a1_p[0]=a1_p[0]+a1_v1_0;
          acs_fds_c=acs_fds_c-1; der_var_obj=acs_fds[acs_fds_c];
          v1_0=der_x[4];
          a1_v1_0=a1_der_var_obj; a1_der_var_obj=0;
          a1_der_x[4]=a1_der_x[4]+a1_v1_0;
          acs_fds_c=acs_fds_c-1; var_obj=acs_fds[acs_fds_c];
          v1_0=x[4];
          a1_v1_0=a1_var_obj; a1_var_obj=0;
          a1_x[4]=a1_x[4]+a1_v1_0;
          acs_fds_c=acs_fds_c-1; der_var_accel=acs_fds[acs_fds_c];
          v1_0=der_x[3];
          a1_v1_0=a1_der_var_accel; a1_der_var_accel=0;
          a1_der_x[3]=a1_der_x[3]+a1_v1_0;
          acs_fds_c=acs_fds_c-1; var_accel=acs_fds[acs_fds_c];
          v1_0=x[3];
          a1_v1_0=a1_var_accel; a1_var_accel=0;
          a1_x[3]=a1_x[3]+a1_v1_0;
          acs_fds_c=acs_fds_c-1; der_var_velo=acs_fds[acs_fds_c];
          v1_0=der_x[2];
          a1_v1_0=a1_der_var_velo; a1_der_var_velo=0;
          a1_der_x[2]=a1_der_x[2]+a1_v1_0;
          acs_fds_c=acs_fds_c-1; var_velo=acs_fds[acs_fds_c];
          v1_0=x[2];
          a1_v1_0=a1_var_velo; a1_var_velo=0;
          a1_x[2]=a1_x[2]+a1_v1_0;
          acs_fds_c=acs_fds_c-1; der_var_dist=acs_fds[acs_fds_c];
          v1_0=der_x[1];
          a1_v1_0=a1_der_var_dist; a1_der_var_dist=0;
          a1_der_x[1]=a1_der_x[1]+a1_v1_0;
          acs_fds_c=acs_fds_c-1; var_dist=acs_fds[acs_fds_c];
          v1_0=x[1];
          a1_v1_0=a1_var_dist; a1_var_dist=0;
          a1_x[1]=a1_x[1]+a1_v1_0;
          acs_fds_c=acs_fds_c-1; der_var_ttime=acs_fds[acs_fds_c];
          v1_0=der_x[0];
          a1_v1_0=a1_der_var_ttime; a1_der_var_ttime=0;
          a1_der_x[0]=a1_der_x[0]+a1_v1_0;
          acs_fds_c=acs_fds_c-1; var_ttime=acs_fds[acs_fds_c];
          v1_0=x[0];
          a1_v1_0=a1_var_ttime; a1_var_ttime=0;
          a1_x[0]=a1_x[0]+a1_v1_0;
        }
      }
   }
   if (bmode_1==2) {
      res(yy, der_x, x, p, condit, lock, prev, n_x, n_p, n_c);
   }
}
